image: golang:1.15-buster

variables:
  VERSION: 0.0.${CI_PIPELINE_IID}
  REPO_NAME: gitlab.com/parker.johansen/advent-of-code-2020

# The problem is that to be able to use go get, one needs to put
# the repository in the $GOPATH. So for example if your gitlab domain
# is gitlab.com, and that your repository is namespace/project, and
# the default GOPATH being /go, then you'd need to have your
# repository in /go/src/gitlab.com/namespace/project
# Thus, making a symbolic link corrects this.
before_script:
  - apt-get update && apt-get install -y make
  - mkdir -p $GOPATH/src/$(dirname $REPO_NAME)
  - ln -svf $CI_PROJECT_DIR $GOPATH/src/$REPO_NAME
  - cd $GOPATH/src/$REPO_NAME

stages:
  - test
  - build
  - deploy

format:
  stage: test
  script:
    - make format

test:
  stage: test
  script:
    - make test


build:
  stage: build
  script:
    - make publish PROJECT_DIR=${CI_PROJECT_DIR}
  artifacts:
    name: advent-of-code-2020-${VERSION}
    paths:
      - aoc
